#if !defined (octave_IDA_h)
#define octave_IDA_h 1

#include <cfloat>

#include <ida.h>
#include <ida_dense.h>
#include <nvector_serial.h>

class
OCTAVE_API
IDA : public DAE
{
public:
  
  IDA (void)
    : DAE (), initialized (false), abs_tol (), rel_tol (), mem (NULL) { }

  IDA (double tm, const ColumnVector& s, DAEFunc& f)
    : DAE (s, tm, f), initialized (false), abs_tol (), rel_tol (), mem (NULL) { }

  IDA (double tm, const ColumnVector& s, const ColumnVector& deriv, DAEFunc& f)
    : DAE(s, deriv, tm, f), initialized (false), abs_tol (), rel_tol (), mem (NULL) { }

  ~IDA (void) 
  { 
	IDAFree(&mem);
  }

  ColumnVector do_integrate (double t);

  void set_options (double rtol, double atol);

//  Matrix do_integrate (const ColumnVector& tout);

//  Matrix do_integrate (const ColumnVector& tout, const ColumnVector& tcrit);

  Matrix integrate (const ColumnVector& tout, Matrix& xdot_out);

//  Matrix integrate (const ColumnVector& tout, Matrix& xdot_out,
//                    const ColumnVector& tcrit);

//  std::string error_message (void) const;

private:
  bool initialized;

  void *mem;
  double abs_tol;
  double rel_tol;
};

#endif
